signal.h File Reference

Namespaces | Functions
signal.h File Reference
`#include <af/defines.h>`

Go to the source code of this file.

## Namespaces
| af

## Functions
AFAPI array | approx1 (const array &in, const array &pos, const interpType method=AF_INTERP_LINEAR, const float offGrid=0.0f)
| C++ Interface for data interpolation on one dimensional signals. More...
AFAPI array | approx2 (const array &in, const array &pos0, const array &pos1, const interpType method=AF_INTERP_LINEAR, const float offGrid=0.0f)
| C++ Interface for data interpolation on two dimensional signals. More...
AFAPI array | fftNorm (const array &in, const double norm_factor, const dim_t odim0=0)
| C++ Interface for fast fourier transform on one dimensional signals. More...
AFAPI array | fft2Norm (const array &in, const double norm_factor, const dim_t odim0=0, const dim_t odim1=0)
| C++ Interface for fast fourier transform on two dimensional signals. More...
AFAPI array | fft3Norm (const array &in, const double norm_factor, const dim_t odim0=0, const dim_t odim1=0, const dim_t odim2=0)
| C++ Interface for fast fourier transform on three dimensional signals. More...
AFAPI void | fftInPlace (array &in, const double norm_factor=1)
| C++ Interface for fast fourier transform on one dimensional signals. More...
AFAPI void | fft2InPlace (array &in, const double norm_factor=1)
| C++ Interface for fast fourier transform on two dimensional signals. More...
AFAPI void | fft3InPlace (array &in, const double norm_factor=1)
| C++ Interface for fast fourier transform on three dimensional signals. More...
AFAPI array | fft (const array &in, const dim_t odim0=0)
| C++ Interface for fast fourier transform on one dimensional signals. More...
AFAPI array | fft2 (const array &in, const dim_t odim0=0, const dim_t odim1=0)
| C++ Interface for fast fourier transform on two dimensional signals. More...
AFAPI array | fft3 (const array &in, const dim_t odim0=0, const dim_t odim1=0, const dim_t odim2=0)
| C++ Interface for fast fourier transform on three dimensional signals. More...
AFAPI array | dft (const array &in, const double norm_factor, const dim4 outDims)
| C++ Interface for fast fourier transform on any(1d, 2d, 3d) dimensional signals. More...
AFAPI array | dft (const array &in, const dim4 outDims)
| C++ Interface for fast fourier transform on any(1d, 2d, 3d) dimensional signals. More...
AFAPI array | dft (const array &in)
| C++ Interface for fast fourier transform on any(1d, 2d, 3d) dimensional signals. More...
AFAPI array | ifftNorm (const array &in, const double norm_factor, const dim_t odim0=0)
| C++ Interface for inverse fast fourier transform on one dimensional signals. More...
AFAPI array | ifft2Norm (const array &in, const double norm_factor, const dim_t odim0=0, const dim_t odim1=0)
| C++ Interface for inverse fast fourier transform on two dimensional signals. More...
AFAPI array | ifft3Norm (const array &in, const double norm_factor, const dim_t odim0=0, const dim_t odim1=0, const dim_t odim2=0)
| C++ Interface for inverse fast fourier transform on three dimensional signals. More...
AFAPI void | ifftInPlace (array &in, const double norm_factor=1)
| C++ Interface for fast fourier transform on one dimensional signals. More...
AFAPI void | ifft2InPlace (array &in, const double norm_factor=1)
| C++ Interface for fast fourier transform on two dimensional signals. More...
AFAPI void | ifft3InPlace (array &in, const double norm_factor=1)
| C++ Interface for fast fourier transform on three dimensional signals. More...
AFAPI array | ifft (const array &in, const dim_t odim0=0)
| C++ Interface for inverse fast fourier transform on one dimensional signals. More...
AFAPI array | ifft2 (const array &in, const dim_t odim0=0, const dim_t odim1=0)
| C++ Interface for inverse fast fourier transform on two dimensional signals. More...
AFAPI array | ifft3 (const array &in, const dim_t odim0=0, const dim_t odim1=0, const dim_t odim2=0)
| C++ Interface for inverse fast fourier transform on three dimensional signals. More...
AFAPI array | idft (const array &in, const double norm_factor, const dim4 outDims)
| C++ Interface for inverse fast fourier transform on any(1d, 2d, 3d) dimensional signals. More...
AFAPI array | idft (const array &in, const dim4 outDims)
| C++ Interface for inverse fast fourier transform on any(1d, 2d, 3d) dimensional signals. More...
AFAPI array | idft (const array &in)
| C++ Interface for inverse fast fourier transform on any(1d, 2d, 3d) dimensional signals. More...
template<int rank>
array | fftR2C (const array &in, const dim4 &dims, const double norm_factor=0)
| C++ Interface for real to complex fast fourier transform for one dimensional signals. More...
template<int rank>
array | fftR2C (const array &in, const double norm_factor=0)
| C++ Interface for real to complex fast fourier transform for one dimensional signals. More...
template<int rank>
array | fftC2R (const array &in, bool is_odd=false, const double norm_factor=0)
| C++ Interface for complex to real fast fourier transform. More...
AFAPI array | convolve (const array &signal, const array &filter, const convMode mode=AF_CONV_DEFAULT, const convDomain domain=AF_CONV_AUTO)
| C++ Interface for convolution any(one through three) dimensional signals. More...
AFAPI array | convolve (const array &col_filter, const array &row_filter, const array &signal, const convMode mode=AF_CONV_DEFAULT)
| C++ Interface for separable convolution on two dimensional signals. More...
AFAPI array | convolve1 (const array &signal, const array &filter, const convMode mode=AF_CONV_DEFAULT, const convDomain domain=AF_CONV_AUTO)
| C++ Interface for convolution on one dimensional signals. More...
AFAPI array | convolve2 (const array &signal, const array &filter, const convMode mode=AF_CONV_DEFAULT, const convDomain domain=AF_CONV_AUTO)
| C++ Interface for convolution on two dimensional signals. More...
AFAPI array | convolve3 (const array &signal, const array &filter, const convMode mode=AF_CONV_DEFAULT, const convDomain domain=AF_CONV_AUTO)
| C++ Interface for convolution on three dimensional signals. More...
AFAPI array | fftConvolve (const array &signal, const array &filter, const convMode mode=AF_CONV_DEFAULT)
| C++ Interface for FFT-based convolution any(one through three) dimensional signals. More...
AFAPI array | fftConvolve1 (const array &signal, const array &filter, const convMode mode=AF_CONV_DEFAULT)
| C++ Interface for convolution on one dimensional signals. More...
AFAPI array | fftConvolve2 (const array &signal, const array &filter, const convMode mode=AF_CONV_DEFAULT)
| C++ Interface for convolution on two dimensional signals. More...
AFAPI array | fftConvolve3 (const array &signal, const array &filter, const convMode mode=AF_CONV_DEFAULT)
| C++ Interface for convolution on three dimensional signals. More...
AFAPI array | fir (const array &b, const array &x)
| C++ Interface for finite impulse response filter. More...
AFAPI array | iir (const array &b, const array &a, const array &x)
| C++ Interface for infinite impulse response filter. More...
AFAPI array | medfilt (const array &in, const dim_t wind_length=3, const dim_t wind_width=3, const borderType edge_pad=AF_PAD_ZERO)
| C++ Interface for median filter. More...
AFAPI array | medfilt1 (const array &in, const dim_t wind_width=3, const borderType edge_pad=AF_PAD_ZERO)
| C++ Interface for median filter. More...
AFAPI array | medfilt2 (const array &in, const dim_t wind_length=3, const dim_t wind_width=3, const borderType edge_pad=AF_PAD_ZERO)
| C++ Interface for median filter. More...
AFAPI af_err | af_approx1 (af_array *out, const af_array in, const af_array pos, const af_interp_type method, const float offGrid)
| C Interface for signals interpolation on one dimensional signals. More...
AFAPI af_err | af_approx2 (af_array *out, const af_array in, const af_array pos0, const af_array pos1, const af_interp_type method, const float offGrid)
| C Interface for signals interpolation on two dimensional signals. More...
AFAPI af_err | af_fft (af_array *out, const af_array in, const double norm_factor, const dim_t odim0)
| C Interface for fast fourier transform on one dimensional signals. More...
AFAPI af_err | af_fft_inplace (af_array in, const double norm_factor)
| C Interface for fast fourier transform on one dimensional signals. More...
AFAPI af_err | af_fft2 (af_array *out, const af_array in, const double norm_factor, const dim_t odim0, const dim_t odim1)
| C Interface for fast fourier transform on two dimensional signals. More...
AFAPI af_err | af_fft2_inplace (af_array in, const double norm_factor)
| C Interface for fast fourier transform on two dimensional signals. More...
AFAPI af_err | af_fft3 (af_array *out, const af_array in, const double norm_factor, const dim_t odim0, const dim_t odim1, const dim_t odim2)
| C Interface for fast fourier transform on three dimensional signals. More...
AFAPI af_err | af_fft3_inplace (af_array in, const double norm_factor)
| C Interface for fast fourier transform on three dimensional signals. More...
AFAPI af_err | af_ifft (af_array *out, const af_array in, const double norm_factor, const dim_t odim0)
| C Interface for inverse fast fourier transform on one dimensional signals. More...
AFAPI af_err | af_ifft_inplace (af_array in, const double norm_factor)
| C Interface for fast fourier transform on one dimensional signals. More...
AFAPI af_err | af_ifft2 (af_array *out, const af_array in, const double norm_factor, const dim_t odim0, const dim_t odim1)
| C Interface for inverse fast fourier transform on two dimensional signals. More...
AFAPI af_err | af_ifft2_inplace (af_array in, const double norm_factor)
| C Interface for fast fourier transform on two dimensional signals. More...
AFAPI af_err | af_ifft3 (af_array *out, const af_array in, const double norm_factor, const dim_t odim0, const dim_t odim1, const dim_t odim2)
| C Interface for inverse fast fourier transform on three dimensional signals. More...
AFAPI af_err | af_ifft3_inplace (af_array in, const double norm_factor)
| C Interface for fast fourier transform on three dimensional signals. More...
AFAPI af_err | af_fft_r2c (af_array *out, const af_array in, const double norm_factor, const dim_t pad0)
| C Interface for real to complex fast fourier transform for one dimensional signals. More...
AFAPI af_err | af_fft2_r2c (af_array *out, const af_array in, const double norm_factor, const dim_t pad0, const dim_t pad1)
| C Interface for real to complex fast fourier transform for two dimensional signals. More...
AFAPI af_err | af_fft3_r2c (af_array *out, const af_array in, const double norm_factor, const dim_t pad0, const dim_t pad1, const dim_t pad2)
| C Interface for real to complex fast fourier transform for three dimensional signals. More...
AFAPI af_err | af_fft_c2r (af_array *out, const af_array in, const double norm_factor, const bool is_odd)
| C Interface for complex to real fast fourier transform for one dimensional signals. More...
AFAPI af_err | af_fft2_c2r (af_array *out, const af_array in, const double norm_factor, const bool is_odd)
| C Interface for complex to real fast fourier transform for two dimensional signals. More...
AFAPI af_err | af_fft3_c2r (af_array *out, const af_array in, const double norm_factor, const bool is_odd)
| C Interface for complex to real fast fourier transform for three dimensional signals. More...
AFAPI af_err | af_convolve1 (af_array *out, const af_array signal, const af_array filter, const af_conv_mode mode, af_conv_domain domain)
| C Interface for convolution on one dimensional signals. More...
AFAPI af_err | af_convolve2 (af_array *out, const af_array signal, const af_array filter, const af_conv_mode mode, af_conv_domain domain)
| C Interface for convolution on two dimensional signals. More...
AFAPI af_err | af_convolve3 (af_array *out, const af_array signal, const af_array filter, const af_conv_mode mode, af_conv_domain domain)
| C Interface for convolution on three dimensional signals. More...
AFAPI af_err | af_convolve2_sep (af_array *out, const af_array col_filter, const af_array row_filter, const af_array signal, const af_conv_mode mode)
| C Interface for separable convolution on two dimensional signals. More...
AFAPI af_err | af_fft_convolve1 (af_array *out, const af_array signal, const af_array filter, const af_conv_mode mode)
| C Interface for FFT-based convolution on one dimensional signals. More...
AFAPI af_err | af_fft_convolve2 (af_array *out, const af_array signal, const af_array filter, const af_conv_mode mode)
| C Interface for FFT-based convolution on two dimensional signals. More...
AFAPI af_err | af_fft_convolve3 (af_array *out, const af_array signal, const af_array filter, const af_conv_mode mode)
| C Interface for FFT-based convolution on three dimensional signals. More...
AFAPI af_err | af_fir (af_array *y, const af_array b, const af_array x)
| C Interface for finite impulse response filter. More...
AFAPI af_err | af_iir (af_array *y, const af_array b, const af_array a, const af_array x)
| C Interface for infinite impulse response filter. More...
AFAPI af_err | af_medfilt (af_array *out, const af_array in, const dim_t wind_length, const dim_t wind_width, const af_border_type edge_pad)
| C Interface for median filter. More...
AFAPI af_err | af_medfilt1 (af_array *out, const af_array in, const dim_t wind_width, const af_border_type edge_pad)
| C Interface for 1D median filter. More...
AFAPI af_err | af_medfilt2 (af_array *out, const af_array in, const dim_t wind_length, const dim_t wind_width, const af_border_type edge_pad)
| C Interface for median filter. More...
AFAPI af_err | af_set_fft_plan_cache_size (size_t cache_size)
| C Interface for setting plan cache size. More...

## Function Documentation

## § af_fft_convolve1()

AFAPI af_err af_fft_convolve1 | ( | af_array * | out,
|  | const af_array | signal,
|  | const af_array | filter,
|  | const af_conv_mode | mode
| ) |  |

C Interface for FFT-based convolution on one dimensional signals.

Parameters

  [out] | out | is convolved array
  [in] | signal | is the input signal
  [in] | filter | is the signal that shall be used for the convolution operation
  [in] | mode | indicates if the convolution should be expanded or not(where output size equals input)

Returns
  AF_SUCCESS if the convolution is successful, otherwise an appropriate error code is returned.

## § af_set_fft_plan_cache_size()

AFAPI af_err af_set_fft_plan_cache_size | ( | size_t | cache_size | ) |

C Interface for setting plan cache size.

This function doesn't do anything if called when CPU backend is active. The plans associated with the most recently used array sizes are cached.

Parameters

  [in] | cache_size | is the number of plans that shall be cached